Index: src/edu/ucsb/nceas/metacat/MetacatReplication.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetacatReplication.java	(revision 1291)
+++ src/edu/ucsb/nceas/metacat/MetacatReplication.java	(revision 1292)
@@ -1333,6 +1400,169 @@
   }
   
   /**
+   * Method to get a host server information for given docid
+   * @param conn a connection to the database
+   */
+  public static Hashtable getHomeServerInfoForDocId(String docId)
+  {
+    Hashtable sl = new Hashtable();
+    DBConnection dbConn = null;
+    int serialNumber = -1;
+    //MetaCatUtil ut=new MetaCatUtil();
+    docId=MetaCatUtil.getDocIdFromString(docId);
+    PreparedStatement pstmt=null;
+    int serverLocation;
+    try
+    {
+      //get conection
+      dbConn=DBConnectionPool.
+                  getDBConnection("ReplicationHandler.getHomeServer");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      //get a server location from xml_document table
+      pstmt=dbConn.prepareStatement("select server_location from xml_documents "
+                                            +"where docid = ?");
+      pstmt.setString(1, docId);
+      pstmt.execute();
+      ResultSet serverName = pstmt.getResultSet();
+      //get a server location
+      if(serverName.next())
+      {
+        serverLocation=serverName.getInt(1);
+        pstmt.close();
+      }
+      else
+      {
+        pstmt.close();
+        //ut.returnConnection(conn);
+        return null;
+      }
+      pstmt=dbConn.prepareStatement("select server, last_checked, replicate " +
+                        "from xml_replication where serverid = ?");
+      //increase usage count
+      dbConn.increaseUsageCount(1);
+      pstmt.setInt(1, serverLocation);
+      pstmt.execute();
+      ResultSet rs = pstmt.getResultSet();
+      boolean tableHasRows = rs.next();
+      if (tableHasRows)
+      {
+        
+          String server = rs.getString(1);
+          String last_checked = rs.getString(2);
+          if(!server.equals("localhost"))
+          {
+            sl.put(server, last_checked);
+          }
+        
+      }
+      else
+      {
+        pstmt.close();
+        //ut.returnConnection(conn);
+        return null;
+      }
+      pstmt.close();
+    }
+    catch(Exception e)
+    {
+      System.out.println("error in replicationHandler.getHomeServer(): " +
+                         e.getMessage());
+    }
+    finally
+    {
+      try
+      {
+        pstmt.close();
+        //ut.returnConnection(conn);
+      }
+      catch (Exception ee)
+      {
+        MetaCatUtil.debugMessage("Eror irn rplicationHandler.getHomeServer() "+
+                          "to close pstmt: "+ee.getMessage(), 30);
+      }
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }
+    
+    }//finally
+    return sl;
+  }
+  
+  /**
+   * Returns a home server location  given a accnum
+   * @param accNum , given accNum for a document
+   * 
+   */
+  public static int getHomeServerCodeForDocId(String accNum) throws Exception
+  {
+    DBConnection dbConn = null;
+    int serialNumber = -1;
+    PreparedStatement pstmt = null;
+    int serverCode = 1;
+    //MetaCatUtil ut = new MetaCatUtil();
+    String docId=MetaCatUtil.getDocIdFromString(accNum);
+
+    try 
+    {
+
+      // Get DBConnection
+      dbConn=DBConnectionPool.
+                  getDBConnection("ReplicationHandler.getServerLocation");
+      serialNumber=dbConn.getCheckOutSerialNumber();
+      pstmt=dbConn.prepareStatement("SELECT server_location FROM xml_documents " 
+                              + "WHERE docid LIKE '" + docId + "'");
+      pstmt.execute();
+      ResultSet rs = pstmt.getResultSet();
+      boolean tablehasrows = rs.next();
+      //If a document is find, return the server location for it
+      if ( tablehasrows ) 
+      {  
+        serverCode = rs.getInt(1);
+        pstmt.close();
+        //conn.close();
+        return serverCode;
+      }
+      //if couldn't find in xml_documents table, we think server code is 1
+      //(this is new document)
+      else
+      {
+        pstmt.close();
+        //conn.close();
+        return serverCode;
+      }
+      
+    } 
+    catch(Exception e) 
+    {
+      
+      throw e;
+
+    } 
+    finally 
+    {
+      try 
+      {
+        pstmt.close();
+        //conn.close();
+        
+      } 
+      catch(Exception ee) 
+      {
+        MetaCatUtil.debugMessage("Erorr in Replication.getServerLocation "+
+                     "to close pstmt"+ee.getMessage(), 30);
+      }
+      finally
+      {
+        DBConnectionPool.returnDBConnection(dbConn, serialNumber);
+      }//finally
+    }//finally
+   //return serverCode;
+  }
+  
+  
+  
+  /**
    * This method returns the content of a url
    * @param u the url to return the content from
    * @return a string representing the content of the url
Index: src/edu/ucsb/nceas/metacat/DBQuery.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBQuery.java	(revision 1291)
+++ src/edu/ucsb/nceas/metacat/DBQuery.java	(revision 1292)
@@ -824,6 +824,13 @@
     ResultSet rs=null;
     String docIdInSubjectField=null;
     String docIdInObjectField=null;
+    
+    // Check the parameter
+    if (dataPackageDocid == null || dataPackageDocid.equals(""))
+    {
+      return docIdList;
+    }//if
+    
     //the query stirng
     String query="SELECT subject, object from xml_relation where docId = ?";
     try
@@ -865,7 +872,7 @@
     }//try
     catch (SQLException e)
     {
-      util.debugMessage("Error in getDocidListForDataPackage: "
+      MetaCatUtil.debugMessage("Error in getDocidListForDataPackage: "
                             +e.getMessage(), 30);
     }//catch
     finally
@@ -876,7 +883,7 @@
       }//try
       catch (SQLException ee)
       {
-        util.debugMessage("Error in getDocidListForDataPackage: "
+        MetaCatUtil.debugMessage("Error in getDocidListForDataPackage: "
                             +ee.getMessage(), 30);
       }//catch     
       finally
@@ -892,13 +899,20 @@
    * @param dataPackageDocid, the string in docId field of xml_relation table
    */
   private Vector getOldVersionDocidListForDataPackage(String dataPackageDocid)
-                                 throws SQLException, McdbException,Exception
   {
    
     Vector docIdList=new Vector();//return value
     Vector tripleList=null;
     String xml=null;
-   
+    
+     // Check the parameter
+    if (dataPackageDocid == null || dataPackageDocid.equals(""))
+    {
+      return docIdList;
+    }//if
+    
+    try
+    {
       //initial a documentImpl object 
       DocumentImpl packageDocument = 
                   new DocumentImpl(dataPackageDocid);
@@ -925,9 +939,14 @@
           docIdList.add(((Triple)(tripleList.get(i))).getObject());
         }
       }//for
+    }//try
+    catch (Exception e)
+    {
+      MetaCatUtil.debugMessage("Error in getOldVersionAllDocumentImpl: "
+                            +e.getMessage(), 30);
+    }//catch
   
-    
-    
+    // return result
     return docIdList;
   }//getDocidListForPackageInXMLRevisions()  
   
@@ -1010,6 +1029,7 @@
    * If the return value is -5, means no value in rev field for this docid
    */
   private int getCurrentRevFromXMLDoumentsTable(String docId)
+                                                throws SQLException
   {
     int rev=-5;
     PreparedStatement pStmt = null;
@@ -1037,12 +1057,13 @@
       {
         rev=-5;
       }
-      pStmt.close();
+     
     }//try
     catch (SQLException e)
     {
-      util.debugMessage("Error in getCurrentRevFromXMLDoumentsTable: "
+      MetaCatUtil.debugMessage("Error in getCurrentRevFromXMLDoumentsTable: "
                             +e.getMessage(), 30);
+      throw e;
     }//catch
     finally
     {
@@ -1089,10 +1110,12 @@
 
   
   /**
-   *transfer a docid vetor to a documentImpl vector. The documentImpl vetor 
-   *only inlcudes current version
-   *@param docIdList, a vetor hold a docid list for a data package. In docid,
-   *there is not version number in it.
+   * Transfer a docid vetor to a documentImpl vector. The documentImpl vetor 
+   * only inlcudes current version. If a DocumentImple object
+   * couldn't find for a docid, then the String of this docid was added to vetor
+   * rather than DocumentImple object.
+   * @param docIdList, a vetor hold a docid list for a data package. In docid,
+   * there is not version number in it.
    */  
   
   private Vector getCurrentAllDocumentImpl( Vector docIdList)
@@ -1102,40 +1125,59 @@
     Vector documentImplList=new Vector();
     int rev=0; 
     
-    /*if (conn == null || conn.isClosed())
+    // Check the parameter
+    if (docIdList.isEmpty())
     {
-      dbConn = util.openDBConnection();
-    }
-    else
-    {
-      dbConn=conn;
-    }*/
+      return documentImplList;
+    }//if
+  
     //for every docid in vector
     for (int i=0;i<docIdList.size();i++)
     {
-      //get newest version for this docId
-      rev=getCurrentRevFromXMLDoumentsTable((String)docIdList.elementAt(i));
+      try
+      {
+        //get newest version for this docId
+        rev=getCurrentRevFromXMLDoumentsTable((String)docIdList.elementAt(i));
+      
+        // There is no record for this docId in xml_documents table
+        if (rev ==-5)
+        {
+          // Rather than put DocumentImple object, put a String Object(docid)
+          // into the documentImplList
+          documentImplList.add((String)docIdList.elementAt(i));
+          // Skip other code
+          continue;
+        }
      
-      String docidPlusVersion=((String)docIdList.elementAt(i))
+        String docidPlusVersion=((String)docIdList.elementAt(i))
                         +util.getOption("accNumSeparator")+rev;
-      //create new documentImpl object
-      DocumentImpl documentImplObject = 
+      
+      
+        //create new documentImpl object
+        DocumentImpl documentImplObject = 
                                     new DocumentImpl(docidPlusVersion);
-      //add them to vector                            
-      documentImplList.add(documentImplObject);
-      
+       //add them to vector                            
+        documentImplList.add(documentImplObject);
+      }//try
+      catch (Exception e)
+      {
+        MetaCatUtil.debugMessage("Error in getCurrentAllDocumentImpl: "
+                            +e.getMessage(), 30);
+        // continue the for loop
+        continue;
+      }
     }//for
     return documentImplList;
   }
   
   /**
-   *transfer a docid vetor to a documentImpl vector. The documentImpl vetor 
-   *does not inlcude old version
-   *@param docIdList, a vetor hold a docid list for a data package. In docid,
-   *there is version number in it.
+   * Transfer a docid vetor to a documentImpl vector. If a DocumentImple object
+   * couldn't find for a docid, then the String of this docid was added to vetor
+   * rather than DocumentImple object.
+   * @param docIdList, a vetor hold a docid list for a data package. In docid,
+   *t here is version number in it.
    */    
   private Vector getOldVersionAllDocumentImpl( Vector docIdList)
-                              throws McdbException,Exception
   {
     //Connection dbConn=null;
     Vector documentImplList=new Vector();
@@ -1143,28 +1185,49 @@
     String uniqueId=null;
     int rev=0; 
     
-    /*if (conn == null || conn.isClosed())
+    // Check the parameter
+    if (docIdList.isEmpty())
     {
-      dbConn = util.openDBConnection();
-    }
-    else
-    {
-      dbConn=conn;
-    }*/
+      return documentImplList;
+    }//if
+    
     //for every docid in vector
     for (int i=0;i<docIdList.size();i++)
     {
       
         String docidPlusVersion=(String)(docIdList.elementAt(i));
-        //create new documentImpl object
-        DocumentImpl documentImplObject = 
+        
+        try
+        {
+          //create new documentImpl object
+          DocumentImpl documentImplObject = 
                                     new DocumentImpl(docidPlusVersion);
-        //add them to vector                            
-        documentImplList.add(documentImplObject);
+          //add them to vector                            
+          documentImplList.add(documentImplObject);
+        }//try
+        catch (McdbDocNotFoundException notFoundE)
+        {
+          MetaCatUtil.debugMessage("Error in DBQuery.getOldVersionAllDocument"+
+                                  "Imple" + notFoundE.getMessage(), 30);
+          // Rather than add a DocumentImple object into vetor, a String object
+          // - the doicd was added to the vector
+          documentImplList.add(docidPlusVersion);
+          // Continue the for loop
+          continue;
+        }//catch
+        catch (Exception e)
+        {
+          MetaCatUtil.debugMessage("Error in DBQuery.getOldVersionAllDocument"+
+                                  "Imple" + e.getMessage(), 30);
+          // Continue the for loop
+          continue;
+        }//catch
+          
       
     }//for
     return documentImplList;
-  }
+  }//getOldVersionAllDocumentImple
+  
   /**
    *put a data file into a zip output stream
    *@param docImpl, docmentImpl object which will be sent to zip output stream
@@ -1221,18 +1284,7 @@
     byte[] byteString=null;
     InputStream source;
     DBTransform xmlToHtml;
-    //Connection dbConn;
-
-    //get the connection to the database
-    /*if (conn == null || conn.isClosed())
-    {
-      dbConn = util.openDBConnection();
-    }
-    else
-    {
-      dbConn=conn;
-    }*/
-
+  
     //create a DBTransform ojbect
     xmlToHtml = new DBTransform();
     //head of html
@@ -1239,7 +1291,20 @@
     htmlDoc.append("<html><head></head><body>");
     for (int i=0; i<docImplList.size(); i++)
     {
-      if ((((DocumentImpl)docImplList.elementAt(i)).getDoctype()).
+      // If this String object, this means it is missed data file
+      if ((((docImplList.elementAt(i)).getClass()).toString())
+                                             .equals("class java.lang.String"))
+      {
+        
+        htmlDoc.append("<a href=\"");
+        String dataFileid =(String)docImplList.elementAt(i);
+        htmlDoc.append("./data/").append(dataFileid).append("\">");
+        htmlDoc.append("Data File: ");
+        htmlDoc.append(dataFileid).append("</a><br>");
+        htmlDoc.append("<br><hr><br>");
+        
+      }//if
+      else if ((((DocumentImpl)docImplList.elementAt(i)).getDoctype()).
                                                          compareTo("BIN")!=0)
       { //this is an xml file so we can transform it.
         //transform each file individually then concatenate all of the
@@ -1262,7 +1327,6 @@
       else
       { //this is a data file so we should link to it in the html
         htmlDoc.append("<a href=\"");
-        String dataFileName = null;
         String dataFileid =((DocumentImpl)docImplList.elementAt(i)).getDocID();
         htmlDoc.append("./data/").append(dataFileid).append("\">");
         htmlDoc.append("Data File: ");
@@ -1291,7 +1355,7 @@
    * @param groups, the group of the user
    */
   public ZipOutputStream getZippedPackage(String docIdString, 
-                    ServletOutputStream out, String user, String[] groups)
+        ServletOutputStream out, String user, String[] groups, String passWord)
                     throws ClassNotFoundException, IOException, SQLException, 
                       McdbException, NumberFormatException, Exception
   { 
@@ -1307,32 +1371,24 @@
     
     String docId=null;
     int version=-5;
+    // Docid without revision
     docId=MetaCatUtil.getDocIdFromString(docIdString);
+    // revision number
     version=MetaCatUtil.getVersionFromString(docIdString);
  
-    //get the connection to the database
-    /*if (conn == null || conn.isClosed())
-    {
-      dbConn = util.openDBConnection();
-    }
-    else
-    {
-      dbConn=conn;
-    }*/
-
     //check if the reqused docId is a data package id
     if (!isDataPackageId(docId))//if it is not, throw a exception
     {
       Exception e = new Exception("The request the doc id " +docIdString+
                                     " is not a data package id");
-      //dbConn.close();
       throw e;
     }
+    // Check the permission of user
     else if(!hasPermissionToExportPackage(docId, user, groups))
     {
+      
       Exception e = new Exception("User " + user + " does not have permission"
                        +" to export the data package " + docIdString);
-      //dbConn.close();
       throw e;
     }
     else //it is a packadge id
@@ -1339,11 +1395,13 @@
     { 
       //store the package id
       packageId=docId;
-      //If it is for current version
-      if ((version ==-1)||version==getCurrentRevFromXMLDoumentsTable(packageId))
+      //get current version in database
+      int currentVersion = getCurrentRevFromXMLDoumentsTable(packageId);
+      //If it is for current version (-1 means user didn't specify revision)
+      if ((version ==-1)||version==currentVersion)
       { 
         //get current version number
-        version=getCurrentRevFromXMLDoumentsTable(packageId);
+        version=currentVersion;
         //get package zip entry name
         //it should be docId.revsion.package
         rootName=packageId+util.getOption("accNumSeparator")+version+
@@ -1354,6 +1412,11 @@
         documentImplList=getCurrentAllDocumentImpl(docIdList);
        
       }//if
+      else if (version > currentVersion || version < -1)
+      {
+        throw new Exception ("The user specified docid: "+docId+"."+version
+                                              +" doesn't exist");
+      }//else if
       else  //for an old version
       {
        
@@ -1365,37 +1428,80 @@
         documentImplList=getOldVersionAllDocumentImpl(docIdList);
       }//else  
       
+      // Make sure documentImplist is not empty
+      if (documentImplList.isEmpty())
+      {
+        throw new Exception ("Couldn't find component for data package: "
+                                              + packageId);
+      }//if
       
-      zOut = new ZipOutputStream(out);
-
+     
+       zOut = new ZipOutputStream(out);
       //put every element into zip output stream
       for (int i=0; i < documentImplList.size(); i++ )
       {
-        //create a docmentImpls object (represent xml doc) base on the docId
-        docImpls=(DocumentImpl)documentImplList.elementAt(i);
-        
-        //checking if the user has the permission to read the documents
-        if (docImpls.hasReadPermission(user,groups,docImpls.getDocID()))
-        { 
+        // if the object in the vetor is String, this means we couldn't find
+        // the document locally, we need find it remote
+       if ((((documentImplList.elementAt(i)).getClass()).toString())
+                                             .equals("class java.lang.String"))
+        {
+          // Get String object from vetor
+          String documentId = (String) documentImplList.elementAt(i);
+          MetaCatUtil.debugMessage("docid: "+documentId, 30);
+          // Get doicd without revision
+          String docidWithoutRevision = 
+                                     MetaCatUtil.getDocIdFromString(documentId);
+          MetaCatUtil.debugMessage("docidWithoutRevsion: "
+                                                     +docidWithoutRevision, 30);
+          // Get revision
+          String revision = MetaCatUtil.getRevisionStringFromString(documentId);
+          MetaCatUtil.debugMessage("revsion from docIdentifier: "+revision, 30);
+          // Zip entry string
+          String zipEntryPath = rootName+"/data/"; 
+          // Create a RemoteDocument object
+          RemoteDocument remoteDoc = 
+                          new RemoteDocument(docidWithoutRevision,revision,user, 
+                                                     passWord, zipEntryPath);
+          // Here we only read data file from remote metacat
+          String docType = remoteDoc.getDocType();
+          if (docType!=null)
+          {
+            if (docType.equals("BIN"))
+            {
+              // Put remote document to zip output
+              remoteDoc.readDocumentFromRemoteServerByZip(zOut);
+              // Add String object to htmlDocumentImplList
+              String elementInHtmlList = remoteDoc.getDocIdWithoutRevsion()+
+               MetaCatUtil.getOption("accNumSeparator")+remoteDoc.getRevision();
+              htmlDocumentImplList.add(elementInHtmlList);
+            }//if
+          }//if
+         
+        }//if
+        else
+        {
+          //create a docmentImpls object (represent xml doc) base on the docId
+          docImpls=(DocumentImpl)documentImplList.elementAt(i);
+          //checking if the user has the permission to read the documents
+          if (docImpls.hasReadPermission(user,groups,docImpls.getDocID()))
+          {  
             //if the docImpls is metadata 
-          if ((docImpls.getDoctype()).compareTo("BIN")!=0)  
-          {
+            if ((docImpls.getDoctype()).compareTo("BIN")!=0)  
+            {
               //add metadata into zip output stream
               addDocToZipOutputStream(docImpls, zOut, rootName);
               //add the documentImpl into the vetor which will be used in html
               htmlDocumentImplList.add(docImpls);
            
+            }//if
+            else 
+            {
+              //it is data file 
+              addDataFileToZipOutputStream(docImpls, zOut, rootName);
+              htmlDocumentImplList.add(docImpls);
+            }//else
           }//if
-          
-          else 
-          {
-           
-           //it is data file 
-           addDataFileToZipOutputStream(docImpls, zOut, rootName);
-           htmlDocumentImplList.add(docImpls);
-          }//else
-        }//if
-
+        }//else
       }//for
 
       //add html summary file
Index: src/edu/ucsb/nceas/metacat/MetaCatUtil.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetaCatUtil.java	(revision 1291)
+++ src/edu/ucsb/nceas/metacat/MetaCatUtil.java	(revision 1292)
@@ -380,7 +380,6 @@
    *              1) str1.str2(no version)  version =-1;
    *              2) str1.str2.str3, in this case version = str3;
    *              3) other, vresion =-2
-   * @param the sperator char
    */
   public static int getVersionFromString(String str)
                                 throws NumberFormatException
@@ -408,7 +407,8 @@
     {
       version=-2;
     }
-    else if (dotNumber == 2) //the case for str1.str2.str3
+    else if (dotNumber == 2 && (indexOfLastDot != (str.length() -1))) 
+     //the case for str1.str2.str3
     {
        versionString=str.substring((indexOfLastDot+1), str.length());
        version=Integer.parseInt(versionString);
@@ -421,7 +421,55 @@
     return version;  
   }//getVersionFromString
   
-   /**
+  
+  /** 
+   * Utility method to get version string from a given string
+   * @param string, the given string should be these two format:
+   *              1) str1.str2(no version)  version=null;
+   *              2) str1.str2.str3, in this case version = str3;
+   *              3) other, vresion =null;
+   */
+  public static String getRevisionStringFromString(String str)
+                                throws NumberFormatException
+  {
+    // String to store the version
+    String versionString=null;
+    int dotNumber = 0;//count how many dots in given string
+    int indexOfLastDot = 0;
+    
+    //assume that seperator is one charactor string
+    char seperator=getOption("accNumSeparator").charAt(0);
+    
+    for (int i=0; i<str.length(); i++)
+    {
+      if ( str.charAt(i)==seperator)
+      {
+        dotNumber++;//count how many dots
+        indexOfLastDot=i;//keep the last dot postion
+      }
+    }//for
+    
+    //The string formatt is wrong, because it has more than two or less than
+    //one seperator
+    if ( dotNumber>2 || dotNumber < 1)
+    {
+      versionString = null;
+    }
+    else if (dotNumber == 2 && (indexOfLastDot != (str.length() -1))) 
+    {
+      //the case for str1.str2.str3
+      // indexOfLastDot != (str.length() -1) means get rid of str1.str2.
+      versionString=str.substring((indexOfLastDot+1), str.length());
+    }
+    else if (dotNumber == 1) //the case for str1.str2 or str1.str2.
+    {
+      versionString=null;
+    }
+    
+    return versionString;  
+  }//getVersionFromString
+   
+  /**
    * Method to get the name of local replication server
    */
    public static String getLocalReplicationServerName()
